import { z } from 'zod';
export declare const makePositiveIntegerQueryParser: (title: string) => z.ZodEffects<z.ZodUnion<[z.ZodNumber, z.ZodEffects<z.ZodString, number, string>]>, number, string | number>;
export declare const queryLimitParser: z.ZodEffects<z.ZodUnion<[z.ZodNumber, z.ZodEffects<z.ZodString, number, string>]>, number, string | number>;
export declare const firestoreQueryLimitParser: z.ZodEffects<z.ZodEffects<z.ZodUnion<[z.ZodNumber, z.ZodEffects<z.ZodString, number, string>]>, number, string | number>, number, string | number>;
export declare const queryOffsetParser: z.ZodEffects<z.ZodUnion<[z.ZodNumber, z.ZodEffects<z.ZodString, number, string>]>, number, string | number>;
export declare const firestoreQueryOffsetParser: z.ZodEffects<z.ZodUnion<[z.ZodNumber, z.ZodEffects<z.ZodString, number, string>]>, number, string | number>;
export declare const makeLimitParser: <T extends z.ZodType<any, z.ZodTypeDef, any>>(parser: T) => z.ZodObject<{
    limit: T;
}, "strip", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    limit: T;
}>, undefined extends T["_output"] ? never : "limit"> extends infer T_1 ? { [k_1 in keyof T_1]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    limit: T;
}>, undefined extends T["_output"] ? never : "limit">[k_1]; } : never, z.baseObjectInputType<{
    limit: T;
}> extends infer T_2 ? { [k_2 in keyof T_2]: z.baseObjectInputType<{
    limit: T;
}>[k_2]; } : never>;
export declare const makeOffsetParser: <T extends z.ZodType<any, z.ZodTypeDef, any>>(parser: T) => z.ZodObject<{
    offset: T;
}, "strip", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    offset: T;
}>, undefined extends T["_output"] ? never : "offset"> extends infer T_1 ? { [k_1 in keyof T_1]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    offset: T;
}>, undefined extends T["_output"] ? never : "offset">[k_1]; } : never, z.baseObjectInputType<{
    offset: T;
}> extends infer T_2 ? { [k_2 in keyof T_2]: z.baseObjectInputType<{
    offset: T;
}>[k_2]; } : never>;
export declare const makeLimitOffsetParser: <LP extends z.ZodType<any, z.ZodTypeDef, any>, OP extends z.ZodType<any, z.ZodTypeDef, any>>(limitParser: LP, offsetParser: OP) => z.ZodObject<{
    limit: OP;
    offset: LP;
}, "strip", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    limit: OP;
    offset: LP;
}>, (undefined extends OP["_output"] ? never : "limit") | (undefined extends LP["_output"] ? never : "offset")> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    limit: OP;
    offset: LP;
}>, (undefined extends OP["_output"] ? never : "limit") | (undefined extends LP["_output"] ? never : "offset")>[k]; } : never, z.baseObjectInputType<{
    limit: OP;
    offset: LP;
}> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<{
    limit: OP;
    offset: LP;
}>[k_1]; } : never>;
export declare const queryOffsetLimitParser: z.ZodObject<{
    limit: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodNumber, z.ZodEffects<z.ZodString, number, string>]>, number, string | number>>;
    offset: z.ZodDefault<z.ZodEffects<z.ZodUnion<[z.ZodNumber, z.ZodEffects<z.ZodString, number, string>]>, number, string | number>>;
}, "strip", z.ZodTypeAny, {
    offset: number;
    limit?: number | undefined;
}, {
    limit?: string | number | undefined;
    offset?: string | number | undefined;
}>;
export declare const firestoreListLimitParamsParser: z.ZodObject<{
    limit: z.ZodDefault<z.ZodOptional<z.ZodEffects<z.ZodEffects<z.ZodUnion<[z.ZodNumber, z.ZodEffects<z.ZodString, number, string>]>, number, string | number>, number, string | number>>>;
}, "strip", z.ZodTypeAny, {
    limit: number;
}, {
    limit?: string | number | undefined;
}>;
export declare const firestoreListOffsetParamsParser: z.ZodObject<{
    offset: z.ZodDefault<z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodNumber, z.ZodEffects<z.ZodString, number, string>]>, number, string | number>>>;
}, "strip", z.ZodTypeAny, {
    offset: number;
}, {
    offset?: string | number | undefined;
}>;
export declare const firestoreListParamsParser: z.ZodObject<{
    limit: z.ZodDefault<z.ZodOptional<z.ZodEffects<z.ZodEffects<z.ZodUnion<[z.ZodNumber, z.ZodEffects<z.ZodString, number, string>]>, number, string | number>, number, string | number>>>;
    offset: z.ZodDefault<z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodNumber, z.ZodEffects<z.ZodString, number, string>]>, number, string | number>>>;
}, "strip", z.ZodTypeAny, {
    limit: number;
    offset: number;
}, {
    limit?: string | number | undefined;
    offset?: string | number | undefined;
}>;
