import { StripeCustomerId, StripePayinMethodId } from '../stripe/types';
import { PAYIN_PROVIDER_ORIGIN_TYPES } from './constants';
import z from 'zod';
import { payinProviderParamsParser, payinProviderResultParser } from './parsers';
export type PayinProviderOriginType = (typeof PAYIN_PROVIDER_ORIGIN_TYPES)[number];
export type PaypalCustomerId = 'paypal';
export type PayinProviderCustomerId = StripeCustomerId | PaypalCustomerId;
export type PayinProviderCustomerIdPerOriginType = {
    paypal: PaypalCustomerId;
    stripe: StripeCustomerId;
};
export type PayinProviderPaymentMethodIdPerOriginType = {
    paypal: string;
    stripe: StripePayinMethodId;
};
export type PayinProviderOriginId = PayinProviderCustomerId;
export type PayinProviderParams = z.infer<typeof payinProviderParamsParser>;
export type PayinProviderResult = z.infer<typeof payinProviderResultParser>;
