import { stripeCustomerIdParser } from '../stripe/parsers';
import type { PayinProviderCustomerId } from './types';
import { paypalCustomerIdParser } from '../paypal/parsers';
import z from 'zod';
import { PAYIN_PROVIDER_ORIGIN_TYPE_PARAM_NAME, PAYIN_PROVIDER_ORIGIN_TYPES } from './constants';

export const payinProviderCustomerIdParser = stripeCustomerIdParser.or(paypalCustomerIdParser).transform((o) => {
  const r: PayinProviderCustomerId = o; // assert
  return r;
});

export const payinProviderOriginTypeParser = z.enum(PAYIN_PROVIDER_ORIGIN_TYPES);

export const payinProviderParamsParser = z.object({
  [PAYIN_PROVIDER_ORIGIN_TYPE_PARAM_NAME]: payinProviderOriginTypeParser,
});

export const payinProviderResultParser = payinProviderCustomerIdParser;
