import { ORIGIN_TYPE_PAYPAL, ORIGIN_TYPE_STRIPE } from '../origin/constants';
import { PAYOUT_METHOD_ORIGIN_TYPES } from '../payoutMethod/constants';

export const PAYOUT_BATCH_ID_PARAM_NAME = 'batchId' as const;

export const PAYOUT_QUEUE_ALL_STATUS = 'all' as const;
export const PAYOUT_QUEUE_PENDING_STATUS = 'pending' as const;
export const PAYOUT_QUEUE_DONE_STATUS = 'done' as const;

export const PAYOUT_QUEUE_STATUSES = [
  PAYOUT_QUEUE_ALL_STATUS,
  PAYOUT_QUEUE_PENDING_STATUS,
  PAYOUT_QUEUE_DONE_STATUS,
] as const;
export const PAYOUT_QUEUE_LINE_GRANULAR_ORIGIN_TYPES = [ORIGIN_TYPE_STRIPE] as const;
export const PAYOUT_QUEUE_NON_LINE_GRANULAR_ORIGIN_TYPES = [ORIGIN_TYPE_PAYPAL] as const;

export const assertPayoutQueueOriginTypesEnums = () => {
  if (
    [...PAYOUT_METHOD_ORIGIN_TYPES].sort().join(',') !==
    [...PAYOUT_QUEUE_LINE_GRANULAR_ORIGIN_TYPES, ...PAYOUT_QUEUE_NON_LINE_GRANULAR_ORIGIN_TYPES].sort().join()
  ) {
    throw new Error(
      'PAYOUT_QUEUE_LINE_NON_GRANULAR_ORIGIN_TYPES and PAYOUT_QUEUE_LINE_GRANULAR_ORIGIN_TYPES must sum to PAYOUT_METHOD_ORIGIN_TYPES'
    );
  }
};

assertPayoutQueueOriginTypesEnums();

export const PAYOUT_QUEUE_ITEM_ATTEMPTS_FIELD_NAME = 'attempts' as const;
export const PAYOUT_QUEUE_ITEM_ATTEMPT_STARTED_AT_FIELD_NAME = 'startedAt' as const;
export const PAYOUT_QUEUE_ITEM_ATTEMPT_ENDED_AT_FIELD_NAME = 'endedAt' as const;
export const PAYOUT_QUEUE_ITEM_ATTEMPT_ERRORS_FIELD_NAME = 'errors' as const;

export const PAYOUT_QUEUE_ITEM_ATTEMPT_ID_PREFIX = 'attempt-' as const;
